import java.util.ArrayList;
import java.util.Iterator;


public class Solver {
	//Liste des threads
	private ArrayList<ThreadResoudre> lthreads;
	
	//Constructeur, crée les threads 
	Solver(Panneau Feuille, ArrayList<Panneau> Debit, boolean quick){
		lthreads=new ArrayList<ThreadResoudre>(8);
		for (int i=1 ; i<9 ; i++)
			lthreads.add(new ThreadResoudre(Feuille, Debit,  quick,  i));
	}
	
	//Lance les threads
	public void go(){
		Iterator<ThreadResoudre> it = lthreads.iterator();
		while (it.hasNext()){
			it.next().start();
		}		
	}
	
	//retourne le nombre de threads actifs
	public int isRunning(){
		int ret=0;
		Iterator<ThreadResoudre> it = lthreads.iterator();
		while (it.hasNext()){
			if (it.next().isAlive())
				ret++;
		}
		return ret;
	}
	

	public Solution getSolution(){
		//Pas de solution valide si le calcul n'est pas fini
		if (isRunning()>0)
			return null;
		
		//Récupère les solutions stockées dans chaque thread
		Iterator<ThreadResoudre> it = lthreads.iterator();
		ArrayList<Solution> lsolut = new ArrayList<Solution>(lthreads.size());
		while (it.hasNext()){
			lsolut.add(it.next().getSolution());
		}
		
		//Trouve la meilleure solution
		int n = Algo.FiltreSolution(lsolut);
		return lsolut.get(n);
	}
}
